/*  wx_plasma engine version 2.0	    

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

var plsin=new Array()
for (var i=0; i<513; i+=1) {
	plsin[i]=Math.round(Math.sin( ((i/180)*Math.PI)/512*360)*1024)
}
function wx_plasma(w,h,tx,ty){
	this.id = "wx_plasma"+(wx_plasma.Count++)
	this.object = this.id + "Object"
	eval(this.object + "=this")

	this.tilesx=tx||10
	this.tilesy=ty||10
	this.tw=Math.round((w||200)/tx)
	this.th=Math.round((h||200)/ty)

	this.setSize((this.tw*tx)+2,(this.th*ty)+2)
	this.setVisible(false)
	this.setBgColor('#ffffff')

	this.palette = new Array()
	DynFunctions.createRedPal(this.palette)
	
	return this
}
wx_plasma.Count=0
wx_plasma.prototype = new DynLayer
wx_plasma.prototype.timerid=null
wx_plasma.prototype.running=false
wx_plasma.prototype.sininc=0
wx_plasma.prototype.getSubClass = function() { return wx_plasma }
wx_plasma.prototype.onCreate=function() {
		this.flyr = new Array()
		this.fcol = new Array()
		for (var x=0; x<this.tilesx; x++) {
			for (var y=0; y<this.tilesy; y++) {
				this.fcol[x+(this.tilesx*y)]=0
				this.flyr[x+(this.tilesx*y)]=new DynLayer()
				this.flyr[x+(this.tilesx*y)].setBgColor(this.palette[0])
				this.flyr[x+(this.tilesx*y)].setSize(this.tw,this.th)
				this.flyr[x+(this.tilesx*y)].moveTo(1+(x*this.tw),1+(y*this.th))
				this.flyr[x+(this.tilesx*y)].setVisible(true)
				this.addChild(this.flyr[x+(this.tilesx*y)])
			}
		}
		DynFunctions.getColor(255,64,128)
	}
wx_plasma.prototype.update=function(){
	fire=this.flyr
	col=this.fcol
	pal=this.palette
	tx=this.tilesx
	ty=this.tilesy

	var a=this.sininc
	for (var x=0; x<tx; x++) {
		xcol=(plsin[((x<<3)+(a))&511]<<5)+
		     (plsin[((x)+(a<<3))&511]<<4)+
		     (plsin[((x>>5)+(a>>4))&511]<<3)
		for (var y=0; y<ty; y++) {
			ycol=(plsin[((y<<5)+(a))&511]<<4)+
			     (plsin[((y)+(a<<2))&511]<<3)+
			     (plsin[((y)+(a>>4))&511]<<5)
			col[x+(tx*y)]=(xcol+ycol)>>10
			if (col[x+(tx*y)]<0) col[x+(tx*y)]-=(col[x+(tx*y)]<<1)
		}
	}
	max=ty*tx
	for (var y=0; y<max; y++) if (is.ns4) fire[y].doc.bgColor=pal[col[y]]
	else fire[y].css.backgroundColor=pal[col[y]]

	this.sininc+=2
	
	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
}
wx_plasma.prototype.start = function () { 
	this.stop()

	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
	else this.timerid = setInterval(this.object+'.update()',25) 
	this.running=true
}
wx_plasma.prototype.stop = function () { 
	if(this.running)
		if (is.ns) clearTimeout(this.timerid)
		else clearInterval(this.timerid)
	this.running = false
}
wx_plasma.prototype.remove=function(){ this.deleteFromParent() }