/*  wx_reflection version 2.0

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_reflection(x,y,w,h){
	this.id = "wx_reflection"+(wx_reflection.Count++)
	this.object = this.id + "Object"
	eval(this.object + "=this")

	this.moveTo(x||0,y||0)
	this.setSize(w||260,h||280)
	this.Background='#000000'

	this.xoffset = 0
	this.yoffset = 0

	this.image =''
	this.lines = new Array()
	this.pattern = new Array()

	this.dlyr = new DynLayer()
	this.dlyr.setVisible(false)
	this.dlyr.setSize(this.w,this.h)

	return this
}
wx_reflection.Count=0
wx_reflection.prototype = new DynLayer
wx_reflection.prototype.timerid = null
wx_reflection.prototype.running = false
wx_reflection.prototype.getSubClass = function() {return wx_reflection }
wx_reflection.prototype.setImage = function(src,w,h) { this.image=new DynAPI.getImage(src,w,h) }
wx_reflection.prototype.setXoffset=function (x) { this.xoffset=x }
wx_reflection.prototype.setYoffset=function (y) { this.yoffset=y }
wx_reflection.prototype.setLines = function (nr) { 
	for (var i=0; i<nr; i+=1) {
		this.lines[i]=new Array()
		this.lines[i]=new DynLayer()
		this.lines[i].setVisible(true)
		this.lines[i].setHTML('<img src="'+this.image.src+'">')
		this.lines[i].setSize(this.w,1)
		this.lines[i].moveTo(this.xoffset,this.yoffset)
		this.addChild(this.lines[i])
	}
}
wx_reflection.prototype.update = function() {
	var al=this.lines.length
	for (var i=0; i<al; i++) {
		l=this.lines[i]
		p=l.p++
		if (is.ns) l.css.left=this.xoffset+(this.pattern[p]*i>>2)
		else l.css.pixelLeft=this.xoffset+(this.pattern[p]*i>>2)
		if (l.p==this.pattern.length) l.p=0
	}
	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
}
wx_reflection.prototype.setPattern = function() {
	if (arguments.length==0) return

	for (var i=0; i<arguments.length; i+=1)	this.pattern[i]=arguments[i]

	var j=0
	for (var i=0; i<this.lines.length; i+=1) {
		if (this.lines[i]==null) this.lines[i]=new Array()
		this.lines[i].moveTo(this.xoffset+this.pattern[j],this.yoffset)
		this.lines[i].p=j
		j+=1
		if (j==this.pattern.length) j=0
	}
}
wx_reflection.prototype.start = function () { 
	this.stop()

	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
	else this.timerid = setInterval(this.object+'.update()',25)
	this.running=true
}
wx_reflection.prototype.stop = function () { 
	if(this.running)
		if (is.ns) clearTimeout(this.timerid)
		else clearInterval(this.timerid)
	this.running = false
}
wx_reflection.prototype.write = function(contents) { this.dlyr.setHTML(contents) }
wx_reflection.prototype.wxreflectionsetVisible=DynLayer.prototype.setVisible
wx_reflection.prototype.setVisible = function (b) { 
	for (var i=0;i<this.lines.length; i+=1) this.lines[i].setClip([i,this.w,(i+this.lines[i].h),0])
	this.wxreflectionsetVisible(true)
}
wx_reflection.prototype.remove = function() { this.deleteFromParent() }
