// BorderFactory.
// Requires modified version of DynAPI.js with padding modifications.


// Alter DynLayer to support borders.
DynLayer.prototype.border=null;
DynLayer.prototype.getBorder=function() {
    return this.border;
}
DynLayer.prototype.setBorder=function(b) {
    if (b==null) this.border.removeFrom(this);
    else b.assignTo(this);
    this.border=b;
}
// Define BorderFactory Constructor.
BorderFactory=function(width,color,style) {
    this.width=(width?width:1);
    this.color=(color?color:"#000000");
    this.style=(style?style:"solid");
    this.target=null;
    this.borders=[
        new DynLayer('',0,0,1,1,this.color,'visible'),
        new DynLayer('',0,0,1,1,this.color,'visible'),
        new DynLayer('',0,0,1,1,this.color,'visible'),
        new DynLayer('',0,0,1,1,this.color,'visible')
    ];
    this.borderEvents=new EventListener(this);
    // Removes borders before a layer is re-loaded
    this.borderEvents.onbeforeload=function(e) {
        e.target.target.removeChild(e.target.borders[0],e.target.borders[1],e.target.borders[2],e.target.borders[3]);
        e.target.target=null;
    }
    // Adds the borders back after a layer is re-loaded
    this.borderEvents.onload=function(e) {
        e.getTarget().assignTo(e.getSource());
    }
    // Resizes the border when the layer is resized.
    this.borderEvents.onresize=function(e) {
        e.getTarget().paint();
    }
    this.borderEvents.onCreate=function(e) {
        e.getTarget().paint();
    }
}
// BorderFactory IS a SuperClass of all borders.
BorderFactory.prototype=new SuperClass();
// 'Static' method to Get a border
BorderFactory.getBorder=function(borderType,width,p1,p2,p3) {
    var b=new BorderFactory(width,p1,p2); // create the lowest level border.
    b.type=borderType;
   // delete(b.getBorder); // remove static method from instance.
    if (BorderFactory[borderType]) // If there is a constructor.. use it.
        BorderFactory[borderType](width,p1,p2,p3); 
    eval('b.inherit(BorderFactory.'+borderType+');');
    return b;
    //new this[borderType](width,p1,p2,p3);
}

BorderFactory.prototype.setWidth=function(w,side) {
    if (this.side)
    this.width=w;
}

BorderFactory.prototype.paint=function() {
    var pc=this.target; // target is the assigned layer.
    var t=this.borders;
    this.borders[0].moveTo(0,0); // Top
    this.borders[1].moveTo(0,0); // Left
    this.borders[2].moveTo(pc.w-t[2].w,0); // Right
    this.borders[3].moveTo(0,pc.h-t[3].h); // Bottom
    this.borders[0].setSize(pc.w,t[0].h);  // top
    this.borders[1].setSize(t[1].w,pc.h);  // Left
    this.borders[2].setSize(t[2].w,pc.h);  // Right
    this.borders[3].setSize(pc.w,t[3].h);  // Bottom
}

BorderFactory.prototype.removeFrom=function() {
    this.target.removeChild(this.borders[0],this.borders[1],this.borders[2],this.borders[3]);
    this.target.removeEventListener(this.borderEvents);
    this.target=null;
}

BorderFactory.prototype.assignTo=function(o) {
    if (o.getClass()!=DynLayer) {
        if (!o.getComponent) return; // need reference to the DynLayer.
        o=o.getComponent();
    }
    if (this.target==o) return;
    if (this.target!=null)
        this.removeFrom(this.target);
    o.addChild(this.borders[0],this.borders[1],this.borders[2],this.borders[3]);
    this.target=o; // set's this border's target layer in which to display.
    o.addEventListener(this.borderEvents);
    if (o.created) {
        this.paint();
        return;
    }
}


/*** Start of BASICBORDER ****/
BorderFactory.BasicBorder=function(){};

BorderFactory.BasicBorder.prototype.setColor=function(c) {
    for (var i=0;i<this.borders.length;i++)
        this.borders[i].setBgColor(c);
    this.color=c;
}
/***  End of BASICBORDER  ****/

/* This was replaced when the onCreate was setup to use invokeEvent.
   Thus, all of the extra, confusing, crap was no-longer needed.
    this.oTarget=o.target;
    if (o.onCreate)
        this.oCreate=o.onCreate;
    o.target=this;
    o.onCreate=function() {
        if (this.oCreate) {
            var t=this.target;
            this.target=this.oTarget;
            this.oCreate();
            this.target=t;
        }
        this.target.paint(); // layout after the previous create method is called.
    }
*/