// DragEvent
// provides drag and drop capabilities to DynLayers
// 2000.03.11

// Copyright (C) 2000 Dan Steinman
// Redistributable under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

function DragEvent(type,src) {
	this.type = type
	this.src = src
	this.dragEnabled = true
	this.bubble = false
}
DragEvent.prototype.getType = function() {return this.type}
DragEvent.prototype.getSource = function() {return this.src}
DragEvent.prototype.getTarget = function() {return this.target}
DragEvent.prototype.bubble = false
DragEvent.prototype.getX = function() {return this.x}
DragEvent.prototype.getY = function() {return this.y}
DragEvent.prototype.getPageX = function() {return this.pageX}
DragEvent.prototype.getPageY = function() {return this.pageY}
DragEvent.prototype.setBubble = function(b) {this.bubble=b}
DragEvent.prototype.cancelDrag = function(b) {this.dragEnabled=false}
DragEvent.dragPlay=3; // 3 pixel play area.
DynAPI.document.dragevent=null;
DragEvent.lyrListener = new EventListener()
DragEvent.lyrListener.onmousedown = function(e) {
    if (DynAPI.document.dragevent) return; // don't allow double event hits.
	var lyr = e.getSource()
	lyr.dragevent = new DragEvent("dragstart",lyr)
	DynAPI.document.dragevent = lyr.dragevent
	var de = lyr.dragevent
	de.isDragging = false;
	de.x = e.getX()
	de.y = e.getY()
	de.pageX = e.getPageX()
	de.pageY = e.getPageY()
	de.parentPageX = lyr.parent.getPageX()
	de.parentPageY = lyr.parent.getPageY()
	//lyr.invokeEvent("dragstart",de) // can't be dragging yet.. we only have a mouse down event.. we haven't moved!
	//e.setBubble(de.bubble);
	//if (is.ns)
        e.setBubble(true); // Needed in netscape.. We'll get the on
}
DragEvent.docListener = new EventListener()
DragEvent.docListener.onmousemove = function(e) {
	var de = DynAPI.document.dragevent
	if (!de) return
	// addition: Make a safe "play" area where the mouse can move w/out starting a drag.
	if (!de.isDragging && Math.abs(de.pageX-e.getPageX())-DragEvent.dragPlay>0) {
	    de.isDragging=true;
	    de.src.invokeEvent("dragstart",de)
    	e.setBubble(de.bubble);
	}
	if (!de.isDragging) return
	else if (!de.dragEnabled) {
		lyr.invokeEvent("mouseup")
		return
	}
	var lyr = de.src
	if (!lyr) return
	de.type = "dragmove"
	de.pageX = e.getPageX()
	de.pageY = e.getPageY()	
	var x = de.pageX-de.parentPageX-de.x
	var y = de.pageY-de.parentPageY-de.y	
	var dB=lyr.dragBoundary
	if (dB=="parent") {
		var b = lyr.parent.getHeight()
		var r = lyr.parent.getWidth()
		var w = lyr.w
		var h = lyr.h		
		if (x<0) x=0
		else if (x+w>r) x = r-w
		if (y<0) y=0
		else if (y+h>b) y = b-h
	}
	lyr.moveTo(x,y)
	lyr.invokeEvent("dragmove",de)
	e.setBubble(de.bubble)
}
DragEvent.docListener.onmouseup = function(e) {
	var de = DynAPI.document.dragevent
	if (!de) return
	if (!de.isDragging) {
    	de.type = "dragend"
    	de.src = null
    	e.setBubble(true)
    	DynAPI.document.dragevent=null;
	    return
	}
	
	var lyr = de.src
	if (!lyr) return
	
	de.type = "dragend"
	if (is.ie)
	    DynAPI.wasDragging=true;
	de.isDragging = false
	lyr.invokeEvent("dragend",de)
	de.src = null
	DynAPI.document.dragevent=null;
	e.setBubble(de.bubble)
}
DragEvent.setDragBoundary = function(widget,t,r,b,l) {
	var a = arguments
	if (a.length==0) return
	var dlyr = widget.getComponent()
	if (a.length==1) dlyr.dragBoundary = "parent"
	else if (a.length==5) this.dragBoundary = new Array(t,r,b,l)
}
DragEvent.enableDragEvents = function() {
	for (var i=0;i<arguments.length;i++) {
		var lyr = arguments[i].getComponent()
		lyr.addEventListener(DragEvent.lyrListener)
	}
	DynAPI.document.addEventListener(DragEvent.docListener)
}
DragEvent.disableDragEvents = function() {
	for (var i=0;i<arguments.length;i++) {
		var lyr = arguments[i].getComponent()
		lyr.removeEventListener(DragEvent.lyrListener)
	}
	// DynAPI.document.removeEventListener(DragEvent.docListener)  // problems for multiple drags
}
