// ScrollArea Object
// simple method-scrollable area where content can be written
// 2000.06.01

// DynAPI Copyright (C) 2000 Dan Steinman
// Modified for DynAPI2 by IlMaestro ( ilmaestro@cantir.com )
// Redistributable under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

function ScrollArea(content) {
	this.component = new DynLayer()
	this.component.setParentComponent(this)
	this.content = this.component.addChild(new DynLayer())

	this.scrollEvent = new EventListener(this)
	this.scrollEvent.onslide = function(e) {
		e.getTarget().invokeEvent('scroll')
	}
	this.content.addEventListener(this.scrollEvent)
	this.resizeListener = new EventListener(this)
	this.resizeListener.onresize = function(e) {
	    var o=e.getTarget();
	    o.child.setMaxSize(o.container,true);
		o.findDimensions()
	}
	this.loadListener = new EventListener(this)
	this.loadListener.onload = function(e) {
	    var o=e.getTarget();
	    o.child.setMaxSize(o.content,true);
		o.findDimensions();
	}
	//this.content.addEventListener(this.loadListener)
	if(content) {
	    this.addChild(content);
	    this.findDimensions();
	} else this.addChild(new DynLayer())
}

WidgetInterface.inherit(ScrollArea)

ScrollArea.prototype.loadHTML = function(url) {
    var l=new DynLayer();
    l.addEventListener(this.loadListener);
    this.addChild(l);
    l.loadHTML(url);
}

ScrollArea.prototype.setSize = function(w,h) {
	this.component.setSize(w,h)
	this.findDimensions()
	this.invokeEvent("scroll")
}
ScrollArea.prototype.addChild = function(child) {
	if (this.content.children.length>0) {
		this.child.removeEventListener(this.resizeListener)
		this.child.removeFromParent()
	}
	this.content.moveTo(0,0)
	
	this.child = child	
	this.content.addChild(child)
	this.child.addEventListener(this.resizeListener)
	this.findDimensions()
	
	this.invokeEvent("scroll")
	return child
}
ScrollArea.prototype.findDimensions = function() {
	this.content.setSize(this.child.getWidth(),this.child.getHeight())
	this.availableScrollX = this.child.getWidth()-this.getWidth()
	this.availableScrollY = this.child.getHeight()-this.getHeight()	
	this.enableVScroll = this.availableScrollY>0
	this.enableHScroll = this.availableScrollX>0
}
ScrollArea.prototype.scrollTo = function(rx,ry) {
	this.content.moveTo(rx!=null?((-this.availableScrollX)*rx):null,ry!=null?((-this.availableScrollY)*ry):null)
	this.invokeEvent("scroll")
}
ScrollArea.prototype.scrollUp = function() {this.scrollSlide(null,0)}
ScrollArea.prototype.scrollDown = function() {this.scrollSlide(null,-this.availableScrollY)}
ScrollArea.prototype.scrollLeft = function() {this.scrollSlide(0,null)}
ScrollArea.prototype.scrollRight = function() {this.scrollSlide(-this.availableScrollX,null)}
ScrollArea.prototype.scrollSlide = function(x,y) {
	if (x!=null && this.enableHScroll) {
		this.invokeEvent("scrollstart")
		this.content.slideTo(x,null)
	}
	if (y!=null && this.enableVScroll) {
		this.invokeEvent("scrollstart")
		this.content.slideTo(null,y)
	}
}
ScrollArea.prototype.cancelScroll = function() {
	this.content.slideActive=false
	this.invokeEvent("scrollend")
}
