/*  wx_slider version 1.1

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_slider(x,y,w,h,theme) {
	this.id = "wx_slider"+(wx_slider.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")
	
	this.moveTo(x||0,y||0)
	this.setSize(w||128,h||36)

	this.theme=theme||''
		
	this.setVisible(false)
	
	this.slider=new DynLayer()
	this.slider.moveTo(0,0)
	
	return this
}
wx_slider.Count=0
wx_slider.prototype = new DynLayer
wx_slider.prototype.dragging=false
wx_slider.prototype.position=0
wx_slider.prototype.maxbar=64
wx_slider.prototype.timerid=null
wx_slider.prototype.autoinc=0
wx_slider.prototype.vertical=false
wx_slider.prototype.sliderbar='slider-bar.gif'
wx_slider.prototype.sliderhandle='slider-handle.gif'
wx_slider.prototype.getSubClass=function() { return wx_slider }
wx_slider.prototype.setMax=function(m) { this.maxbar=m }
wx_slider.prototype.onChange=function() { }
wx_slider.prototype.setVertical=function(b) {
		this.vertical=b
		if (this.vertical) {
			this.sliderbar='slider-bar-vertical.gif'
			this.sliderhandle='slider-handle-vertical.gif'
		} else {
			this.sliderbar='slider-bar.gif'
			this.sliderhandle='slider-handle.gif'
		}
	}
wx_slider.prototype.calcPosition=function(vl) {
		if (this.vertical) this.position=Math.round(vl/Math.round(this.h/this.maxbar))
		else this.position=Math.round(vl/Math.round(this.w/this.maxbar))

		if (this.position<0) this.position=0
		if (this.position>this.maxbar) this.position=this.maxbar
		
		this.setPosition(this.position)
	}
wx_slider.prototype.setPosition=function(pos) {
		if (pos>this.maxbar) pos=this.maxbar
		if (pos<0) pos=0
		this.position=pos
		
		if (this.vertical) {
			this.target=Math.round(this.h/this.maxbar)*pos
			if (this.target<0) this.target=0
			if (this.target>this.h-this.slider.h) this.target=this.h-this.slider.h
			this.slider.moveTo(null,this.target)
		} else {
			this.target=Math.round(this.w/this.maxbar)*pos
			if (this.target<0) this.target=0
			if (this.target>this.w-this.slider.w) this.target=this.w-this.slider.w
			this.slider.moveTo(this.target,null)
		}
		this.onChange()
	}
wx_slider.prototype.onCreate=function() {
		this.setHTML('<img src="'+this.theme+this.sliderbar+'" width="'+this.w+'" height="'+this.h+'">')

		this.slider.setHTML('<img src="'+this.theme+this.sliderhandle+'">')
		
		this.canvas=new DynLayer()
		this.canvas.setSize(this.w,this.h)
		this.canvas.moveTo(0,0)

		this.addChild(this.slider)
		this.addChild(this.canvas)
		
		this.events=new EventListener(this)
		this.events.onmousedown=function(e) {
			me=e.getTarget()
			if (me.vertical) {
				if (e.y>=me.slider.y && e.y<me.slider.y+me.slider.h) me.dragging=true
			} else {
				if (e.x>=me.slider.x && e.x<me.slider.x+me.slider.w) me.dragging=true
			}
			
			if (!me.dragging) me.timerid=setTimeout(me.object+'.update()',250)
			e.setBubble(false)
		}
		this.events.onmousemove=function(e) {
			me=e.getTarget()
			if (me.vertical) {
				if (e.y<me.target) me.autoinc=-1
				else me.autoinc=1
			} else {
				if (e.x<me.target) me.autoinc=-1
				else me.autoinc=1
			}
			
			if (me.dragging) {
				if (me.vertical) me.calcPosition(e.y)
				else me.calcPosition(e.x)
			}
			e.setBubble(false)
		}
		this.events.onmouseup=function(e) {
			me=e.getTarget()
		
			if (me.timerid) clearTimeout(me.timerid)
			if (me.dragging) me.dragging=false
			else {
				if (me.vertical) {
					if (e.y<me.target) me.setPosition(me.position-1)
					else me.setPosition(me.position+1)
				} else {
					if (e.x<me.target) me.setPosition(me.position-1)
					else me.setPosition(me.position+1)
				}
			}
			e.setBubble(false)
		}
		
		this.canvas.addEventListener(this.events)
	}
wx_slider.prototype.update=function() {
		this.setPosition(this.position+this.autoinc)
		this.timerid = setTimeout(this.object+'.update()',50)
	}