<?

/*

PEngines 0.1 (April 27, 2000)
a customizable search engine front end
http://www.dansteinman.com/php/pengines/

Copyright (C) 1999 Dan Steinman (dan@dansteinman.com)

This is free software under the terms of the GNU General Public License

*/

include('dplib.php3');  // Dan's PHP Library
include('class.pengines.php3');  // PEngines Class

// -- DPLib: make a database connection ------------

$mysql = new MySQLDatabase;
$mysql->setDB('localhost','myuser','mypass');
$mysql->select_db('myportal');

// -- DPLib: username password login ------------
$phPortalSettings = http_getCookieSet('phportal');
if ($phPortalSettings) {
	$username = $phPortalSettings->data["username"];
	$password = $phPortalSettings->data["password"];
	$mysql->checkPassword($username,$password,null);
}
else {
	debug("bad username/password");
}
if ($username == "guest") debug("cannot use guest account here");

// -- PEngines ------------

$engines = new PEngines($mysql);

// -- PEngines: custom default page ------------

// if no command print a custom default page with links to auto-submit and edit the engine forms
if (!$command) {

	// returns array with all the saved form data needed
	$forms = $engines->getSavedForms();
		
	// this is a javascript function to submit the hidden form
	print '	
	<script language="JavaScript">

	PEngines = {
		search : function() {
			var p = document["pengines"]
			var f = document[p.which.options[p.which.selectedIndex].value]
			f[this.queryFields[f.name]].value = p.query.value
			f.submit()
		},
		queryFields : new Array()
	}
	';
	
	for ($i=0;$i<count($forms);$i++) {
		$formname = $forms[$i]['formname'];
		$queryfield = $forms[$i]['queryfield'];
		
		print "PEngines.queryFields['$formname'] = '$queryfield';\n";
	}
	
	print "</script>
	<h3>Welcome $username</h3>
	<p><a href=\"pengines.php3?command=editengines\">Edit engines</a>
	<br><a href=\"pengines.php3?command=makeengine\">Make a new engine</a>
	<p>Here is your custom universal search engine:<br>
	";
	
	if (!count($forms)) {
		print "no engines available";
	}
	else {
		print '<form name="pengines" onSubmit="PEngines.search(); return false;">
		<select name="which">';
		
		// loop through each form
		for ($i=0;$i<count($forms);$i++) {
	
			$engine = $forms[$i]['engine'];  // the name of the engine
			$formname = $forms[$i]['formname'];  // the name of the form to submit
			$queryfield = $forms[$i]['queryfield'];
			
			print "<option value=\"$formname\">$engine</option>";
		}
		
		print '</select>
		<input type=text name=query size=20>
		<input type=submit value="Search">
		</form>
		';
		
		// print hidden forms to the page for submitting
		print $engines->getHiddenFormsString();
	}
}

// -- PEngines: built-in routines ------------

// the edit page
else if ($command == "editengines") {
	$engines->displayEditEngines();
}
// the routine for deleting an engine
else if ($command == "deleteengine") {
	$engines->deleteEngine();
}
// the page to enter a url to examine
else if ($command == "makeengine") {
	$engines->displayMakeEngine();
}
// the page which returns the results of the url
else if ($command == "submitmakeengine") {
	$engines->displaySubmitMakeEngine($url);
}
// save the form data to the database
else if ($command == "saveengine") {
	$engines->displaySaveEngine();
}

?>
